package com.zipcodewilmington.phonebook;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.TreeMap;

/**
 * Created by leon on 1/23/18.
 */
public class PhoneBook {

    TreeMap<String, ArrayList<String>> phoneBook;


    public PhoneBook() {
        this.phoneBook = new TreeMap<>();
    }

    public void add(String name, String phoneNumber) {

        if (!hasEntryName(name)) {
            ArrayList<String> numbers = new ArrayList<>();
            numbers.add(phoneNumber);
            this.phoneBook.put(name, numbers);
        } else {
            this.phoneBook.get(name).add(phoneNumber);
        }

    }

    public ArrayList<String> lookup(String name) {
        return this.phoneBook.get(name);
    }

    public void remove(String name, String phoneNumber) {
        this.phoneBook.get(name).remove(phoneNumber);
    }

    public void removeRecord(String name) {
        this.phoneBook.remove(name);
    }

    public boolean hasEntryName(String name) {
        return phoneBook.containsKey(name);
    }

    public ArrayList<String> getArrayListForNames() {
        ArrayList<String> nameList = new ArrayList<String>(phoneBook.keySet());
        return nameList;
    }

    public ArrayList<ArrayList<String>> getArrayListForNumbers() {
        ArrayList<ArrayList<String>> numberList = new ArrayList<ArrayList<String>>(phoneBook.values());
        return numberList;
    }

    public String listNamesAndNumbers() {

        ArrayList<String> namesList = new ArrayList<>(getArrayListForNames());
        ArrayList<ArrayList<String>> numbersList = new ArrayList<>(getArrayListForNumbers());
        String namesAndNumbers = "";

        for (int i = 0; i < namesList.size(); i++) {
            namesAndNumbers = namesAndNumbers + String.format("%20s %14s", namesList.get(i), numbersList.get(i)) + "\n";
        }

            return namesAndNumbers;

    }

    public String reverseLookup(String number) {

        ArrayList<String> nameList = new ArrayList<String>(getArrayListForNames());
        ArrayList<ArrayList<String>> numberList = new ArrayList<ArrayList<String>>(getArrayListForNumbers());

        String result = "";

        for (int i = 0; i < nameList.size(); i++) {

            ArrayList<String> currentNumbers = new ArrayList<>(numberList.get(i));

            for (int j = 0; j < currentNumbers.size(); j++) {

                if (currentNumbers.get(j).equals(number)) {
                    result = nameList.get(i);
                }


            }

        }

        return result;
    }


}
